--------------------------------------------------------------  
--  Subject : Abstract data type 
--  Copyright (c) 1999 by A.Baranovsky
--------------------------------------------------------------

class Point
  function SetPoint( iX, iY ) constructor
  function GetX()                        
  function GetY()                        
  function "<"( Z )                      
  function ">"( Z )   
  function "+"( U, V )
  function "-"( U, V )
  function "-1"( U )                      
  function "[]"( N )                      
  function Show()
end

class Circle : Point                         
 function SetCircle( iX, iY, iR ) constructor   
 function GetR()                                
 function Show() 
 function "+"( U, V ) 
end

implementation Point

  local X, Y, N              

  function CalcNorm()
    N := X*X + Y*Y
  return 0
                             
  function SetPoint( iX, iY )
    X := iX
    Y := iY
    CalcNorm()
  return NIL                 

  function Norm() inline           
  return N                 

  function GetX() inline           
  return X

  function GetY() inline           
  return Y

  function "<"( Z )       
  return N < Z.Norm()                  

  function ">"( Z )           
  return N > Z.Norm()

  function "+"( U, V )
    X := U.GetX() + V.GetX()
    Y := U.GetY() + V.GetY()
    CalcNorm()
  return 0

  function "-"( U, V )
    X := U.GetX() - V.GetX()
    Y := U.GetY() - V.GetY()
    CalcNorm() 
  return 0

  function "-1"( U )
    X := - U.GetX()
    Y := - U.GetY()
  return 0

  function "[]"( I ) 
    if    ClassOf( I ) = ClassInteger then
      if     I = 1 then
         R == X
      elsif  I = 2 then
         R == Y
      else
        raise ERangeError()    
      end 
    elsif ClassOf( I ) = ClassString  then
      if     I = 'X' then 
         R == X
      elsif  I = 'Y' then
         R == Y
      else
        raise ERangeError()    
      end 
    else
      raise ERangeError()   
    end
  return R   





  function Show()    
    writeln( 'POINT ' +STR(X)+' '+STR(Y)+' '+STR(N) )             
  return 0
end


implementation Circle
  local R                          
  function SetCircle( iX, iY, iR )
    SetPoint( iX, iY )           
    R := iR                    
  return NIL

  function GetR() inline               
  return R

  function "+"( U, V ) 
    Point."+"( U, V ) 
    R := ( U.GetR() + V.GetR() ) / 2
  return 0

  function Show()     
    writeln( 'CIRCLE '+STR(GetX())+' '+STR(GetY())+' '+STR(Norm())+' '+STR(R) )                      
  return 0
end

return

